---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for SPEC PTS clock counter test control and status registers
---------------------------------------------------------------------------------------
-- File           : ../rtl/clkcnt_csr.vhd
-- Author         : auto-generated by wbgen2 from clkcnt_csr.wb
-- Created        : Tue May 21 12:18:24 2013
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE clkcnt_csr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity clkcnt_csr is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(2 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
-- Port for BIT field: 'Counter full' in reg: 'Counter full status'
    clkcnt_stat_cnt_full_i                   : in     std_logic;
-- Port for std_logic_vector field: 'Reserved register' in reg: 'Counter full status'
    clkcnt_stat_reserved0_i                  : in     std_logic_vector(30 downto 0);
-- Port for BIT field: 'Counter error' in reg: 'Counter error status'
    clkcnt_stat_cnt_err_i                    : in     std_logic;
-- Port for std_logic_vector field: 'Reserved register' in reg: 'Counter error status'
    clkcnt_stat_reserved1_i                  : in     std_logic_vector(30 downto 0);
-- Port for BIT field: 'Clock output enable' in reg: 'Clock output enable control'
    clkcnt_ctrl_clk_oe_o                     : out    std_logic;
-- Port for std_logic_vector field: 'Reserved register' in reg: 'Clock output enable control'
    clkcnt_ctrl_reserved2_o                  : out    std_logic_vector(30 downto 0);
-- Port for std_logic_vector field: 'Counter top value' in reg: 'Counter top value control'
    clkcnt_ctrl_cnt_top_o                    : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Counter value' in reg: 'Counter value status'
    clkcnt_stat_cnt_val_i                    : in     std_logic_vector(31 downto 0);
-- Port for BIT field: 'Counter reset' in reg: 'Counter reset control'
    clkcnt_ctrl_cnt_rst_o                    : out    std_logic;
-- Port for std_logic_vector field: 'Reserved register' in reg: 'Counter reset control'
    clkcnt_ctrl_reserved3_o                  : out    std_logic_vector(30 downto 0);
-- Port for BIT field: 'Counter enable' in reg: 'Counter enable control'
    clkcnt_ctrl_cnt_en_o                     : out    std_logic;
-- Port for std_logic_vector field: 'Reserved register' in reg: 'Counter enable control'
    clkcnt_ctrl_reserved4_o                  : out    std_logic_vector(30 downto 0)
  );
end clkcnt_csr;

architecture syn of clkcnt_csr is

signal clkcnt_ctrl_clk_oe_int                   : std_logic      ;
signal clkcnt_ctrl_reserved2_int                : std_logic_vector(30 downto 0);
signal clkcnt_ctrl_cnt_top_int                  : std_logic_vector(31 downto 0);
signal clkcnt_ctrl_cnt_rst_int                  : std_logic      ;
signal clkcnt_ctrl_reserved3_int                : std_logic_vector(30 downto 0);
signal clkcnt_ctrl_cnt_en_int                   : std_logic      ;
signal clkcnt_ctrl_reserved4_int                : std_logic_vector(30 downto 0);
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(2 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      clkcnt_ctrl_clk_oe_int <= '0';
      clkcnt_ctrl_reserved2_int <= "0000000000000000000000000000000";
      clkcnt_ctrl_cnt_top_int <= "00000000000000000000000000000000";
      clkcnt_ctrl_cnt_rst_int <= '0';
      clkcnt_ctrl_reserved3_int <= "0000000000000000000000000000000";
      clkcnt_ctrl_cnt_en_int <= '0';
      clkcnt_ctrl_reserved4_int <= "0000000000000000000000000000000";
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          ack_in_progress <= '0';
        else
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(2 downto 0) is
          when "000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(0) <= clkcnt_stat_cnt_full_i;
            rddata_reg(31 downto 1) <= clkcnt_stat_reserved0_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(0) <= clkcnt_stat_cnt_err_i;
            rddata_reg(31 downto 1) <= clkcnt_stat_reserved1_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "010" => 
            if (wb_we_i = '1') then
              clkcnt_ctrl_clk_oe_int <= wrdata_reg(0);
              clkcnt_ctrl_reserved2_int <= wrdata_reg(31 downto 1);
            end if;
            rddata_reg(0) <= clkcnt_ctrl_clk_oe_int;
            rddata_reg(31 downto 1) <= clkcnt_ctrl_reserved2_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "011" => 
            if (wb_we_i = '1') then
              clkcnt_ctrl_cnt_top_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= clkcnt_ctrl_cnt_top_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= clkcnt_stat_cnt_val_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "101" => 
            if (wb_we_i = '1') then
              clkcnt_ctrl_cnt_rst_int <= wrdata_reg(0);
              clkcnt_ctrl_reserved3_int <= wrdata_reg(31 downto 1);
            end if;
            rddata_reg(0) <= clkcnt_ctrl_cnt_rst_int;
            rddata_reg(31 downto 1) <= clkcnt_ctrl_reserved3_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "110" => 
            if (wb_we_i = '1') then
              clkcnt_ctrl_cnt_en_int <= wrdata_reg(0);
              clkcnt_ctrl_reserved4_int <= wrdata_reg(31 downto 1);
            end if;
            rddata_reg(0) <= clkcnt_ctrl_cnt_en_int;
            rddata_reg(31 downto 1) <= clkcnt_ctrl_reserved4_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- Counter full
-- Reserved register
-- Counter error
-- Reserved register
-- Clock output enable
  clkcnt_ctrl_clk_oe_o <= clkcnt_ctrl_clk_oe_int;
-- Reserved register
  clkcnt_ctrl_reserved2_o <= clkcnt_ctrl_reserved2_int;
-- Counter top value
  clkcnt_ctrl_cnt_top_o <= clkcnt_ctrl_cnt_top_int;
-- Counter value
-- Counter reset
  clkcnt_ctrl_cnt_rst_o <= clkcnt_ctrl_cnt_rst_int;
-- Reserved register
  clkcnt_ctrl_reserved3_o <= clkcnt_ctrl_reserved3_int;
-- Counter enable
  clkcnt_ctrl_cnt_en_o <= clkcnt_ctrl_cnt_en_int;
-- Reserved register
  clkcnt_ctrl_reserved4_o <= clkcnt_ctrl_reserved4_int;
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
